﻿'
' Copyright (c) 2021, MindFusion LLC - Bulgaria.
'

Imports System.ComponentModel
Imports System.Xml

Imports Microsoft.Win32
Imports MindFusion.Diagramming.Wpf.Commands


''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
    Inherits Window
    Private mIDelete As MenuItem = Nothing

    Public Sub New()
        InitializeComponent()

        Dim document As New XmlDocument()
        document.LoadXml(My.Resources.Diagram)
        diagram.LoadFromXml(document)

        AddHandler diagram.NodeCreated, AddressOf OnNodeCreated
        AddHandler diagram.EnterInplaceEditMode, AddressOf OnEnterInplaceEditMode
        diagram.Selection.StrokeThickness = 0.2

        mIDelete = New MenuItem()
        mIDelete.Header = "Delete"
        AddHandler mIDelete.Click, AddressOf mIDelete_Click

        _contextMenu = New ContextMenu()
        _contextMenu.Items.Add(mIDelete)
        Me.ContextMenu = _contextMenu

        Dim defAnch As New SolidColorBrush(Colors.Red)

        ' get shape by string id
        _nodes = New Node() _
        { _
        New Node( _
        New AnchorPattern(New AnchorPoint() _
           { _
           New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch) _
           }), Shapes.Alternative.Id), _
           New Node(New AnchorPattern(New AnchorPoint() _
           { _
           New AnchorPoint(30, 0, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 30, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.PunchedCard.Id), _
         New Node(AnchorPattern.Decision2In2Out, Shapes.Decision.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Delay.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(15, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(85, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(85, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(15, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.DirectAccessStorage.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 20, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 80, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 80, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 20, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.DiskStorage.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(40, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(85, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(85, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(40, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Display.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.DividedEvent.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.DividedProcess.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 90, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 90, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 90, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Document.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.InternalStorage.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(25, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(75, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 25, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 25, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.BeginLoop.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(50, 20, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 40, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Input.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(80, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(20, 100, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.ManualOperation.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
           { _
           New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(80, 50, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.MessageFromUser.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(20, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(20, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.MessageToUser.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(45, 90, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 90, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.MultiDocument.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
           { _
           New AnchorPoint(0, 10, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(50, 10, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 10, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 90, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(50, 90, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 90, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Microform.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(80, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.PrimitiveFromCall.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(20, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(20, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.PrimitiveToCall.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Procedure.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(15, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(85, 0, True, True, MarkStyle.Circle, defAnch), _
        New AnchorPoint(100, 30, True, True, MarkStyle.Circle, defAnch), _
        New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
        New AnchorPoint(100, 70, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(15, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(85, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 30, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 70, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Start.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(50, 0, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(50, 100, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch) _
         }), Shapes.Tape.Id), _
         New Node(New AnchorPattern(New AnchorPoint() _
           { _
           New AnchorPoint(0, 30, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(0, 52, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 30, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 52, True, True, MarkStyle.Circle, defAnch) _
           }), "Table2x2"), _
         New Node(New AnchorPattern(New AnchorPoint() _
         { _
         New AnchorPoint(0, 30, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 52, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(0, 74, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 30, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 52, True, True, MarkStyle.Circle, defAnch), _
         New AnchorPoint(100, 74, True, True, MarkStyle.Circle, defAnch) _
         }), "Table3x3"), _
         New Node(New AnchorPattern(New AnchorPoint() _
           { _
           New AnchorPoint(0, 50, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(0, 100, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 50, True, True, MarkStyle.Circle, defAnch), _
           New AnchorPoint(100, 100, True, True, MarkStyle.Circle, defAnch) _
           }), "Container") _
           }

        _connectors = New Connector() { _
         New Connector(ArrowHeads.Arrow, "Arrow"), _
         New Connector(ArrowHeads.BackSlash, "Back slash"), _
         New Connector(ArrowHeads.BowArrow, "Bow arrow"), _
         New Connector(ArrowHeads.Circle, "Circle"), _
         New Connector(ArrowHeads.DoubleArrow, "Double arrow"), _
         New Connector(ArrowHeads.None, "None"), _
         New Connector(ArrowHeads.Pentagon, "Pentagon"), _
         New Connector(ArrowHeads.PointerArrow, "Pointer"), _
         New Connector(ArrowHeads.Quill, "Quill"), _
         New Connector(ArrowHeads.Reversed, "Reversed"), _
         New Connector(ArrowHeads.RevTriangle, "Reversed triangle"), _
         New Connector(ArrowHeads.RevWithCirc, "Reversed with Circle"), _
         New Connector(ArrowHeads.RevWithLine, "Reversed with Line"), _
         New Connector(ArrowHeads.Rhombus, "Rhombus"), _
         New Connector(ArrowHeads.Slash, "Slash"), _
         New Connector(ArrowHeads.Tetragon, "Tetragon"), _
         New Connector(ArrowHeads.Triangle, "Triangle")}
        For Each c As Connector In _connectors
            InitConnectorListItems(c)
        Next

        _connectorList.SelectedIndex = 0

        diagram.DocumentPlane.AllowDrop = True
        diagram.UndoManager.UndoEnabled = True
        diagram.UndoManager.History.Capacity = 30
        diagram.Bounds = New Rect(0, 0, 219, 297)

        diagram.ActiveItemHandlesStyle.HandlePen.Thickness = 0.2
        diagram.SelectedItemHandlesStyle.HandlePen.Thickness = 0.2
        diagram.LinkHeadShapeSize = 6
        diagram.CellFrameStyle = CellFrameStyle.None
    End Sub

    Private Sub OnNodeCreated(ByVal sender As Object, ByVal e As NodeEventArgs)
        e.Node.EnabledHandles = AdjustmentHandles.All
        e.Node.TextAlignment = TextAlignment.Center
        e.Node.TextVerticalAlignment = AlignmentY.Center
        If (TypeOf e.Node Is ContainerNode) Then
            Dim containerNode As ContainerNode = CType(e.Node, ContainerNode)
            containerNode.Margin = 4
        End If
    End Sub

    Sub OnEnterInplaceEditMode(sender As Object, e As InPlaceEditEventArgs)
        e.TextBox.FontSize = e.Item.GetDiagramItem().FontSize
        e.TextBox.Padding = New Thickness(0)
    End Sub


    Private Sub mIDelete_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If diagram.ActiveItem Is Nothing Then
            Return
        End If

        diagram.Items.Remove(diagram.ActiveItem)
    End Sub

    Private Sub InitConnectorListItems(ByVal c As Connector)
        Dim sp As New Grid()
        'sp.Background = Brushes.White;
        sp.Height = 25
        sp.Width = 157

        Dim textBlock As New TextBlock()
        'textBlock.Background = Brushes.White;
        textBlock.Text = c.Name
        textBlock.VerticalAlignment = VerticalAlignment.Top
        textBlock.HorizontalAlignment = HorizontalAlignment.Left
        textBlock.Width = 80
        textBlock.Height = 30
        textBlock.Margin = New Thickness(25, 0, 0, 0)

        Dim drawingVisual = New DrawingVisual()
        Dim drawingContext = drawingVisual.RenderOpen()
        Dim defaultStroke = TryCast(GetStyleValue(diagram.DiagramLinkStyle, DiagramLink.StrokeProperty), Brush)
        Dim defaultBrush = TryCast(GetStyleValue(diagram.DiagramLinkStyle, DiagramLink.BrushProperty), Brush)
        drawingContext.DrawLine(New Pen(defaultStroke, 1), New Point(1, 8), New Point(16, 8))
        DiagramLink.DrawArrowhead(drawingContext, New Pen(defaultStroke, 1), defaultBrush, c.Head, New Point(50, 0), New Point(16, 8), _
         New Point(1, 8), 12)
        drawingContext.Close()

        sp.Children.Add(New VisualHost(drawingVisual))
        sp.Children.Add(textBlock)

        _connectorList.Items.Add(sp)
    End Sub

    Public Class VisualHost
        Inherits FrameworkElement
        Protected Overrides ReadOnly Property VisualChildrenCount() As Integer
            Get
                Return 1
            End Get
        End Property

        Protected Overrides Function GetVisualChild(ByVal index As Integer) As Visual
            Return visual
        End Function

        Public Sub New(ByVal visual As DrawingVisual)
            Me.visual = visual
        End Sub

        Private visual As DrawingVisual
    End Class

    Private _nodes As Node() = Nothing
    Private _connectors As Connector() = Nothing

    Private Sub mIFNew_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        diagram.ClearAll()
    End Sub

    Private Sub mIFOpen_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If openFileDialog.ShowDialog() = True Then
            Try
                diagram.LoadFromXml(openFileDialog.FileName)
            Catch
                MessageBox.Show("Invalid file format.")
            End Try
        End If
    End Sub

    Private Sub mIFSave_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If saveFileDialog.ShowDialog() = True Then
            diagram.SaveToXml(saveFileDialog.FileName)
        End If
    End Sub

    Private Sub mIFPreview_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If diagram.Items.Count = 0 Then
            Return
        End If

        diagram.PrintOptions.DocumentName = "Flowchart"
        diagram.PrintOptions.EnableImages = False
        diagram.PrintOptions.EnableInterior = True
        diagram.PrintOptions.EnableShadows = True
        diagram.PrintOptions.Scale = 100
        diagram.PrintPreview()
    End Sub

    Private Sub mIFPrint_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If diagram.Items.Count = 0 Then
            Return
        End If

        diagram.PrintOptions.DocumentName = "Flowchart"
        diagram.PrintOptions.EnableImages = False
        diagram.PrintOptions.EnableInterior = True
        diagram.PrintOptions.EnableShadows = True
        diagram.PrintOptions.Scale = 100
        diagram.Print()
    End Sub

    Private Sub mIExit_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Me.Close()
    End Sub

    Private openFileDialog As New OpenFileDialog()
    Private saveFileDialog As New SaveFileDialog()

    Private Sub mIEdit_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If diagram.UndoManager.History.NextUndo IsNot Nothing Then
            mIEUndo.IsEnabled = True
            mIEUndo.Header = "Undo " + diagram.UndoManager.History.NextUndo.Title
        Else
            mIEUndo.IsEnabled = False
            mIEUndo.Header = "Undo"
        End If
        If diagram.UndoManager.History.NextRedo IsNot Nothing Then
            mIERedo.IsEnabled = True
            mIERedo.Header = "Redo " + diagram.UndoManager.History.NextRedo.Title
        Else
            mIERedo.IsEnabled = False
            mIERedo.Header = "Redo"
        End If
    End Sub

    Private Sub mIEUndo_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        diagram.UndoManager.Undo()
    End Sub

    Private Sub mIERedo_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        diagram.UndoManager.Redo()
    End Sub

    Private Sub diagram_NodeActivated(ByVal sender As Object, ByVal e As NodeEventArgs)
        Dim node As ShapeNode = TryCast(e.Node, ShapeNode)
        If node IsNot Nothing Then
            _selected = New NodeProps()
            _selected.Text = node.Text
            _selected.Brush = TryCast(node.Brush, SolidColorBrush)

            _propertyGrid.SelectedObject = _selected
        End If
    End Sub

    Private _selected As NodeProps

    Private Sub diagram_NodeDeactivated(ByVal sender As Object, ByVal e As NodeEventArgs)
        _propertyGrid.SelectedObject = Nothing
        _selected = Nothing
    End Sub

    Private Sub diagram_LinkClicked(ByVal sender As Object, ByVal e As LinkEventArgs)
        If e.MouseButton <> MouseButton.Right Then
            Return
        End If

        diagram.Selection.Clear()
        e.Link.Selected = True

        Dim pt As Point = diagram.DocToClient(e.MousePosition)
        _contextMenu.PlacementRectangle = New Rect(pt, New Size())
        _contextMenu.Visibility = Visibility.Visible
        '	Show(diagram, pt);
    End Sub

    Private Sub diagram_NodeClicked(ByVal sender As Object, ByVal e As NodeEventArgs)
        If e.MouseButton <> MouseButton.Right Then
            Return
        End If

        diagram.Selection.Clear()
        e.Node.Selected = True

        Dim pt As Point = diagram.DocToClient(e.MousePosition)
        _contextMenu.PlacementRectangle = New Rect(pt, New Size())
        _contextMenu.Visibility = Visibility.Visible
    End Sub

    Private _contextMenu As ContextMenu

    Private Sub _propertyGrid_PropertyValueChanged(ByVal s As Object, ByVal e As System.Windows.Forms.PropertyValueChangedEventArgs)
        If diagram.Selection.Nodes.Count = 0 Then
            Return
        End If

        Dim b As ShapeNode = TryCast(diagram.Selection.Nodes(0), ShapeNode)
        If b Is Nothing Then
            Return
        End If


        ' Create undo record
        Dim cmd As New ChangeItemCmd(b, "Property change")

        b.Text = _selected.Text
        b.Brush = _selected.Brush
        b.Selected = False

        cmd.Execute()
        b.Selected = True
    End Sub

    Private Sub mITOptions_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim dlg As New OptionsDialog()

        dlg.ShowGrid = diagram.ShowGrid
        dlg.BackBrush = TryCast(diagram.BackBrush, SolidColorBrush)
        dlg.NodeBrush = TryCast(GetStyleValue(diagram.ShapeNodeStyle, ShapeNode.BrushProperty), SolidColorBrush)
        dlg.ConnectorBrush = TryCast(GetStyleValue(diagram.DiagramLinkStyle, DiagramLink.BrushProperty), SolidColorBrush)
        dlg.AnchorBrush = _anchorBrush

        dlg.ShowAnchors = diagram.ShowAnchors <> ShowAnchors.Never
        Select Case _anchorStyle
            Case MarkStyle.Circle
                dlg.AnchorStyle = 0
                Exit Select
            Case MarkStyle.Rectangle
                dlg.AnchorStyle = 1
                Exit Select
            Case MarkStyle.X
                dlg.AnchorStyle = 2
                Exit Select
            Case Else
                dlg.AnchorStyle = 0
                Exit Select
        End Select

        If dlg.ShowDialog() = True Then
            Dim shapeNodeStyle As New Style()
            Dim linkStyle As New Style()

            diagram.ShowGrid = dlg.ShowGrid
            diagram.BackBrush = DirectCast(dlg.BackBrush, SolidColorBrush)
            shapeNodeStyle.Setters.Add(New Setter(ShapeNode.BrushProperty, dlg.NodeBrush))
            linkStyle.Setters.Add(New Setter(DiagramLink.BrushProperty, dlg.ConnectorBrush))
            linkStyle.Setters.Add(New Setter(DiagramLink.StrokeProperty, Brushes.Black))
            diagram.ShapeNodeStyle = shapeNodeStyle
            diagram.DiagramLinkStyle = linkStyle
            _anchorBrush = DirectCast(dlg.AnchorBrush, SolidColorBrush)

            diagram.ShowAnchors = If(dlg.ShowAnchors, ShowAnchors.Auto, ShowAnchors.Never)
            Select Case dlg.AnchorStyle
                Case 0
                    _anchorStyle = MarkStyle.Circle
                    Exit Select
                Case 1
                    _anchorStyle = MarkStyle.Rectangle
                    Exit Select
                Case 2
                    _anchorStyle = MarkStyle.X
                    Exit Select
                Case Else
                    _anchorStyle = MarkStyle.Circle
                    Exit Select
            End Select
        End If
    End Sub

    Private Function GetStyleValue(ByVal style As Style, ByVal [property] As DependencyProperty) As Object
        For Each setter As Setter In style.Setters
            If setter.[Property] Is [property] Then
                Return setter.Value
            End If
        Next

        Return Nothing
    End Function

    Private Sub diagram_DragOver(ByVal sender As Object, ByVal e As DragEventArgs)
        If e.Data.GetDataPresent(GetType(DraggedNode)) Then
            e.Effects = DragDropEffects.Copy
        Else
            e.Effects = DragDropEffects.None
        End If
    End Sub

    Private Sub diagram_Drop(ByVal sender As Object, ByVal e As DragEventArgs)
        Dim ap As AnchorPattern = Nothing

        If e.Data.GetDataPresent(GetType(DraggedNode)) Then
            Dim node As DiagramNode = diagram.Nodes(diagram.Nodes.Count - 1)
            If TypeOf node Is ShapeNode Then
                Dim p As Point = diagram.AlignPointToGrid(node.Bounds.Location)
                node.Bounds = New Rect(p.X - 15, p.Y - 15, 30, 30)
                For Each n As Node In _nodes
                    If n.ShapeId.Equals(DirectCast(node, ShapeNode).Shape.Id) Then
                        ap = n.AnchorPattern
                        Exit For
                    End If
                Next
            ElseIf TypeOf node Is TableNode Then
                Dim table As TableNode = TryCast(node, TableNode)
                node.Bounds = New Rect(node.Bounds.Left - 25, node.Bounds.Top - 20, 50, 40)
                If table.RowCount = 2 Then
                    ap = _nodes(_nodes.Length - 3).AnchorPattern
                Else
                    ap = _nodes(_nodes.Length - 2).AnchorPattern
                End If
                table.ConnectionStyle = TableConnectionStyle.Table
                table.CellTextStyle.FontSize = 4
                Dim row As TableNode.Row
                For Each row In table.Rows
                    row.Height = 8
                Next row
            ElseIf TypeOf node Is ContainerNode Then
                ap = _nodes(_nodes.Length - 1).AnchorPattern
                node.Bounds = New Rect(node.Bounds.Left - 25, node.Bounds.Top - 20, 50, 40)
            End If


            For Each point As AnchorPoint In ap.Points
                point.MarkStyle = _anchorStyle
                point.Brush = _anchorBrush
            Next
            node.AnchorPattern = ap
        End If
    End Sub

    Private Class NodeProps
        <Category("Properties")> _
        <Description("The text displayed within the node.")> _
        Public Property Text() As String
            Get
                Return _text
            End Get
            Set(ByVal value As String)
                _text = value
            End Set
        End Property

        <Category("Properties")> _
        <Description("The interior color of the node.")> _
        Public Property Brush() As Brush
            Get
                Return _brush
            End Get
            Set(ByVal value As Brush)
                _brush = value
            End Set
        End Property

        Private _text As String
        Private _brush As Brush
    End Class


    Private Class Node
        Public Sub New(ByVal anchor As AnchorPattern, ByVal shapeId As String)
            _anchor = anchor
            _template = shapeId
        End Sub

        Public ReadOnly Property AnchorPattern() As AnchorPattern
            Get
                Return _anchor
            End Get
        End Property

        Public ReadOnly Property ShapeId() As String
            Get
                Return _template
            End Get
        End Property

        Private _anchor As AnchorPattern
        Private _template As String
    End Class

    Private Class Connector
        Public Sub New(ByVal head As Shape, ByVal name As String)
            _head = head
            _name = name
        End Sub

        Public ReadOnly Property Head() As Shape
            Get
                Return _head
            End Get
        End Property

        Public ReadOnly Property Name() As String
            Get
                Return _name
            End Get
        End Property

        Private _head As Shape
        Private _name As String
    End Class

    Private Sub _connectorTypeCombo_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        Select Case _connectorTypeCombo.SelectedIndex

            Case 0
                diagram.LinkShape = LinkShape.Polyline
                Exit Select
            Case 1
                diagram.LinkShape = LinkShape.Bezier
                Exit Select
            Case 2
                diagram.LinkShape = LinkShape.Cascading
                Exit Select
        End Select
    End Sub

    Private Sub _connectorList_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        Dim si As Integer = _connectorList.SelectedIndex
        If si < 0 OrElse si >= _connectors.Length Then
            Return
        End If

        diagram.LinkHeadShape = _connectors(si).Head
    End Sub


    Private _anchorBrush As SolidColorBrush = Brushes.Red
    Private _anchorStyle As MarkStyle = MarkStyle.Circle
End Class