﻿'
' Copyright (c) 2021, MindFusion LLC - Bulgaria.
'


''' <summary>
''' Interaction logic for OptionsDialog.xaml
''' </summary>
Partial Public Class OptionsDialog
	Inherits Window
	Public Sub New()
		InitializeComponent()
	End Sub

	Private Sub _okBtn_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
		If Not NewColors() Then
			Return
		End If

		DialogResult = True
		Close()
	End Sub

	Private Sub _cancelBtn_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
		DialogResult = False
		Close()
	End Sub

	Private Sub button1_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
		AnchorStyle = 0
		UpdateAnchorStyle()
	End Sub

	Private Sub button2_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
		AnchorStyle = 1
		UpdateAnchorStyle()
	End Sub

	Private Sub button3_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
		AnchorStyle = 2
		UpdateAnchorStyle()
	End Sub

	Private Sub UpdateAnchorStyle()
		_circleBtn.IsEnabled = Not (AnchorStyle = 0)
		_rectBtn.IsEnabled = Not (AnchorStyle = 1)
		_xBtn.IsEnabled = Not (AnchorStyle = 2)
	End Sub

	Private Function NewColors() As Boolean
		Dim err As TextBox = Nothing
		Try
			Dim r As Byte, g As Byte, b As Byte

			err = bBR
			r = [Byte].Parse(bBR.Text)
			err = bBR
			g = [Byte].Parse(bBG.Text)
			err = bBR
			b = [Byte].Parse(bBB.Text)

			_backBrush = New SolidColorBrush(Color.FromRgb(r, g, b))

			err = nBR
			r = [Byte].Parse(nBR.Text)
			err = nBG
			g = [Byte].Parse(nBG.Text)
			err = nBB
			b = [Byte].Parse(nBB.Text)
			_nodeBrush = New SolidColorBrush(Color.FromRgb(r, g, b))

			err = cBR
			r = [Byte].Parse(cBR.Text)
			err = cBR
			g = [Byte].Parse(cBG.Text)
			err = cBR
			b = [Byte].Parse(cBB.Text)
			_connectorBrush = New SolidColorBrush(Color.FromRgb(r, g, b))

			err = aBR
			r = [Byte].Parse(aBR.Text)
			err = aBR
			g = [Byte].Parse(aBG.Text)
			err = aBR
			b = [Byte].Parse(aBB.Text)

			_anchorBrush = New SolidColorBrush(Color.FromRgb(r, g, b))
		Catch exp As Exception
			MessageBox.Show("Error! " + exp.Message)
			err.SelectAll()
			Return False
		End Try

		Return True
	End Function

	Public Property ShowGrid() As Boolean
		Get
			Return CBool(_showGridCheck.IsChecked)
		End Get
		Set(ByVal value As Boolean)
			_showGrid = value
		End Set
	End Property
	Public Property BackBrush() As SolidColorBrush
		Get
			Return _backBrush
		End Get
		Set(ByVal value As SolidColorBrush)
			_backBrush = value
		End Set
	End Property
	Public Property NodeBrush() As SolidColorBrush
		Get
			Return _nodeBrush
		End Get
		Set(ByVal value As SolidColorBrush)
			_nodeBrush = value
		End Set
	End Property
	Public Property ConnectorBrush() As SolidColorBrush
		Get
			Return _connectorBrush
		End Get
		Set(ByVal value As SolidColorBrush)
			_connectorBrush = value
		End Set
	End Property

	Public Property ShowAnchors() As Boolean
		Get
			Return CBool(_showAnchorsCheck.IsChecked)
		End Get
		Set(ByVal value As Boolean)
			_showAnchors = value
		End Set
	End Property
	Public Property AnchorBrush() As SolidColorBrush
		Get
			Return _anchorBrush
		End Get
		Set(ByVal value As SolidColorBrush)
			_anchorBrush = value
		End Set
	End Property
	Public Property AnchorStyle() As Integer
		Get
			Return _anchorStyle
		End Get
		Set(ByVal value As Integer)
			_anchorStyle = value
		End Set
	End Property

	Private _showGrid As Boolean
	Private _backBrush As SolidColorBrush
	Private _nodeBrush As SolidColorBrush
	Private _connectorBrush As SolidColorBrush

	Private _showAnchors As Boolean
	Private _anchorBrush As SolidColorBrush
	Private _anchorStyle As Integer

	Private Sub Window_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
		_showGridCheck.IsChecked = _showGrid
		bBR.Text = _backBrush.Color.R.ToString()
		bBG.Text = _backBrush.Color.G.ToString()
		bBB.Text = _backBrush.Color.B.ToString()

		nBR.Text = _nodeBrush.Color.R.ToString()
		nBG.Text = _nodeBrush.Color.G.ToString()
		nBB.Text = _nodeBrush.Color.B.ToString()

		cBR.Text = _connectorBrush.Color.R.ToString()
		cBG.Text = _connectorBrush.Color.G.ToString()
		cBB.Text = _connectorBrush.Color.B.ToString()

		aBR.Text = _anchorBrush.Color.R.ToString()
		aBG.Text = _anchorBrush.Color.G.ToString()
		aBB.Text = _anchorBrush.Color.B.ToString()

		_showAnchorsCheck.IsChecked = _showAnchors
		UpdateAnchorStyle()
	End Sub
End Class